/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; 
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details. 

You should have received a copy of the GNU General Public License along with this 
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, 
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
hli@hendriklipka.de
*/

package de.hendriklipka.util;

import java.util.Vector;

import org.log4j.Category;

/**
  receiving end of a StringPipeOutput / -Input - pair
*/
public class StringPipeInput extends java.lang.Object
{
    static Category CAT = Category.getInstance(StringPipeInput.class.getName());

    protected StringPipeOutput Output=null;
    protected Vector Data=new Vector(10,10);
    
    public StringPipeInput()
    {
    }
    
    public StringPipeInput(StringPipeOutput writer)
    {
        connect(writer);
    }
    
    /**
        connects this pipe to a StringPipeOutput
    */
    public void connect(StringPipeOutput spo)
    {
        spo.Input=this;
        Output=spo;
    }
    
    void sendTo(String s)
    {
        Data.addElement(s);
    }
    
    /**
        reads a String out of this pipe.
        @return the next String from the pipe
        null, if there is no String available
    */
    public String read()
    {
        synchronized (Data)
        {
            if (0==Data.size())
            {
                return null;
            }
            else
            {
                String s=(String)Data.elementAt(0);
                Data.removeElementAt(0);
                return s;
            }
        }
    }
}
